Package net.shibboleth.idp.attribute

# Interface PairwiseIdStore

All Known Subinterfaces:
  `DurablePairwiseIdStore`

All Known Implementing Classes:
  `ComputedPairwiseIdStore`, `JDBCPairwiseIdStore`

public interface PairwiseIdStore
Storage and retrieval interface for pairwise/targeted identifiers allowing for custom implementations.

Since:
  4.0.0

## Method Summary

Modifier and Type
Method
Description
`PairwiseId`
`getBySourceValue(PairwiseId pid, boolean allowCreate)`
Populate the pairwise ID field for the input object based on the supplied values.

## Method Details

### getBySourceValue

@Nullable PairwiseId getBySourceValue(@Nonnull PairwiseId pid, boolean allowCreate) throws IOException
Populate the pairwise ID field for the input object based on the supplied values.

The input object must contain values for issuer and recipient entityIDs and the principal name, and the pairwise ID will be populated as applicable on output.

The object returned, if non-null, may be, but does not have to be, the same physical object used as input. The original input object should not be referenced further.

Parameters:
  `pid` - object to populate
  `allowCreate` - true iff the caller is authorizing the issuance of a new identifier
Returns:
  object for the given inputs or null if none exists
Throws:
  `IOException` - if an error occurs accessing the store